// Simple OpenGL compute shader!
// By Ingemar Ragnemalm 2022

// Compile like this:

// g++ -o simple simple-cs.cpp CSutilities.c Linux/MicroGlut.c -I Linux/ -DGL_GLEXT_PROTOTYPES -lm -lGL -lX11

#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include <GL/gl.h>
#include "MicroGlut.h"
#include "CSutilities.h"

int main(int argc, char **argv)
{
// Let GLUT/MicroGlut create a GL context
	glutInit (&argc, argv);
	glutInitContextVersion(4, 5);
	glutCreateWindow("Simple");
    
	printf ("Vendor: %s\n", glGetString (GL_VENDOR));
	printf ("Renderer: %s\n", glGetString (GL_RENDERER));
	printf ("Version: %s\n", glGetString (GL_VERSION));
	printf ("GLSL: %s\n", glGetString(GL_SHADING_LANGUAGE_VERSION));

// Load and compile the compute shader    
    GLuint p =loadComputeShader("simple.cs");

	GLuint ssbo, ssbo2; //Shader Storage Buffer Object

	// Some data
#define N 16
	int ac[N];
	int *ptr;
	int i;

// Create buffer, upload data
	glGenBuffers(1, &ssbo);
	glBindBuffer(GL_SHADER_STORAGE_BUFFER, ssbo);
	glBufferData(GL_SHADER_STORAGE_BUFFER, 16 * sizeof(int), &ac, GL_STATIC_DRAW);
	
// Tell it where the input goes!
// The "5" matches a "layuot" number in the shader.
// (Can we ask the shader about the number? I must try that.)
	glBindBufferBase(GL_SHADER_STORAGE_BUFFER, 5, ssbo);

// Get rolling!
    glDispatchCompute(1, 1, 1); //Work groups launch

// Get data back!
	glBindBuffer(GL_SHADER_STORAGE_BUFFER, ssbo);
	ptr = (int *)glMapBuffer(GL_SHADER_STORAGE_BUFFER, GL_READ_ONLY);

	for (i=0; i < 16; i++)
	{
		printf("%d\n", ptr[i]);
	}
}

